Unit MainGame;

interface

Type TSpr = Array[0..255] of Byte;
     PSpr = ^TSpr;

Var Lev : Array[1..40,1..26] of record T,own:Byte; end;
EndState : Byte; { 1 if esc }
F1 : Byte; { Form of player (dragon,man,...) }
Col : Byte; { Color }
Spr : Array[0..57] of PSpr;
Clean : Pointer; { Clear sprite }
CurPass : String;
CurLevel : LongInt;
DrX,DrY : Byte;

Procedure PlayLev;

implementation

Uses LabInit,PlayDig,Dos,Crt,Svga,Key,MidiDrv;

Var F : File;
A,B,C,D,E : LongInt;
HKey : Array[0..255] of Boolean;
X1,Y1,X2,Y2,X3,Y3 : LongInt;
X1D,Y1D,X2D,Y2D : ShortInt; { Direction Flags }
X1M,Y1M : LongInt; { Map coords }
D1 : Byte; { Direction view }
B1 : PSpr;
BT : Pointer;
Frame,Time : LongInt;
Mve,Yam : Boolean; { Is it moving on a tile?, Yama? }
EscExit : Boolean;

Procedure ShowField;
Var X,Y : LongInt;
Begin
  For A:=1 to 40 do
    For B:=1 to 26 do
    Begin
      X:=(A-1)*16;
      Y:=B*16+32;
      If (Lev[A,B].T=13) or (Lev[A,B].T=14) or (Lev[A,B].T=16) or (Lev[A,B].T=17) then
        ShowSpr(Spr[Lev[A,B].T],X,Y,16,16,Lev[A,B].own) else
        ShowImage(Spr[Lev[A,B].T],X,Y,16,16);
    End;
End;

Procedure ShowSpeed;
Var S : String;
A,B : LongInt;
Begin
  A:=(150-CurSpeed) div 10;
  S:='';
  For B:=1 to A do S:=S+'.';
  S:=S+'';
  For B:=Length(S) to 15 do S:=S+'.';
  For A:=0 to 7 do ShowImage(Clean,A*16+246,0,16,16);
  Print(S,246,0,10);
  WaitCycle:=(CurSpeed*WaitTick) div 100;
End;

Procedure InitGame;
Var S : String;
Begin
  Cls(0);
  X1:=LongInt(DrX-1)*16;
  Y1:=LongInt(DrY-1)*16;
  X1D:=0;
  Y1D:=0;
  X1M:=DrX;
  Y1M:=DrY;
  ShowField;
  S:='  : Min                  Max';
  Print(S,86,0,13);
  ShowSpeed;
  Str(CurLevel,S);
  Print('⠦ : '+S,0,16,11);
  Print('஫ : '+CurPass,0,30,11);
  GetMem(B1,256);
  GetMem(BT,17*16);
  GetImage(B1,X1,Y1+48,16,16);
  Frame:=0;
  D1:=1;
  Mve:=False;
  ShowSpr(Spr[F1+D1*3],X1,Y1+48,16,16,Col);
  FillChar(HKey,SizeOf(HKey),False);
  EndState:=0;
  GetMem(Clean,256);
  FillChar(Clean^,256,0);
End;

Procedure Go(B1 : PSpr;Spr : PSpr;X,Y,XD,YD : LongInt); { move object }
Var GB : Byte;
Begin
  If XD=1 then
  Begin
    For C:=0 to 15 do
      Move(Ptr(Seg(B1^),Ofs(B1^)+C shl 4)^,Ptr(Seg(BT^),Ofs(BT^)+C*17)^,16);
    Move(Ptr(Seg(B1^),Ofs(B1^)+1)^,B1^,255);
    For C:=0 to 15 do
    Begin
      D:=GetPixel(X+16,Y+C);
      B1^[C shl 4+15]:=D;
      Mem[Seg(BT^):Ofs(BT^)+C*17+16]:=D;
    End;
    For C:=0 to 15 do
      For D:=0 to 15 do
      Begin
        GB:=Spr^[C shl 4+D];
        If GB=1 then GB:=Col;
        If GB<>0 then
          Mem[Seg(BT^):Ofs(BT^)+C*17+D+1]:=GB;
      End;
    ShowImage(BT,X,Y,17,16);
  End else
  If XD=-1 then
  Begin
    For C:=0 to 15 do
      Move(Ptr(Seg(B1^),Ofs(B1^)+C shl 4)^,Ptr(Seg(BT^),Ofs(BT^)+C*17+1)^,16);
    Move(B1^,Ptr(Seg(B1^),Ofs(B1^)+1)^,255);
    For C:=0 to 15 do
    Begin
      D:=GetPixel(X-1,Y+C);
      B1^[C shl 4]:=D;
      Mem[Seg(BT^):Ofs(BT^)+C*17]:=D;
    End;
    For C:=0 to 15 do
      For D:=0 to 15 do
      Begin
        GB:=Spr^[C shl 4+D];
        If GB=1 then GB:=Col;
        If GB<>0 then
          Mem[Seg(BT^):Ofs(BT^)+C*17+D]:=GB;
      End;
    ShowImage(BT,X-1,Y,17,16);
  End else
  If YD=-1 then
  Begin
    Move(B1^,Ptr(Seg(BT^),Ofs(BT^)+16)^,256);
    Move(B1^,Ptr(Seg(B1^),Ofs(B1^)+16)^,240);
    For C:=0 to 15 do
    Begin
      D:=GetPixel(X+C,Y-1);
      B1^[C]:=D;
      Mem[Seg(BT^):Ofs(BT^)+C]:=D;
    End;
    For C:=0 to 15 do
      For D:=0 to 15 do
      Begin
        GB:=Spr^[C shl 4+D];
        If GB=1 then GB:=Col;
        If GB<>0 then
          Mem[Seg(BT^):Ofs(BT^)+C shl 4+D]:=GB;
      End;
    ShowImage(BT,X,Y-1,16,17);
  End else
  If YD=1 then
  Begin
    Move(B1^,BT^,256);
    Move(Ptr(Seg(B1^),Ofs(B1^)+16)^,B1^,240);
    For C:=0 to 15 do
    Begin
      D:=GetPixel(X+C,Y+16);
      B1^[240+C]:=D;
      Mem[Seg(BT^):Ofs(BT^)+256+C]:=D;
    End;
    For C:=0 to 15 do
      For D:=0 to 15 do
      Begin
        GB:=Spr^[C shl 4+D];
        If GB=1 then GB:=Col;
        If GB<>0 then
          Mem[Seg(BT^):Ofs(BT^)+16+C shl 4+D]:=GB;
      End;
    ShowImage(BT,X,Y,16,17);
  End;
End;

Procedure GoMve(B1 : PSpr;Sp : PSpr;X,Y,XD,YD : LongInt); { move object }
Var GB : Byte;
Os : Byte;
Begin
  If XD=1 then
  Begin
    For C:=0 to 15 do
      Move(Ptr(Seg(B1^),Ofs(B1^)+C shl 4)^,Ptr(Seg(BT^),Ofs(BT^)+C*17+1)^,16);
    Os:=X and 15;
    For C:=0 to 15 do
    Begin
      D:=Spr[11]^[C shl 4+Os];
      Mem[Seg(BT^):Ofs(BT^)+C*17]:=D;
    End;
    For C:=0 to 15 do
      For D:=0 to 15 do
      Begin
        GB:=Sp^[C shl 4+D];
        If GB=1 then GB:=Col;
        If GB<>0 then
          Mem[Seg(BT^):Ofs(BT^)+C*17+D+1]:=GB;
      End;
    ShowImage(BT,X,Y,17,16);
  End else
  If XD=-1 then
  Begin
    For C:=0 to 15 do
      Move(Ptr(Seg(B1^),Ofs(B1^)+C shl 4)^,Ptr(Seg(BT^),Ofs(BT^)+C*17)^,16);
    Os:=15-(X and 15);
    For C:=0 to 15 do
    Begin
      D:=Spr[11]^[C shl 4+Os];
      Mem[Seg(BT^):Ofs(BT^)+C*17+16]:=D;
    End;
    For C:=0 to 15 do
      For D:=0 to 15 do
      Begin
        GB:=Sp^[C shl 4+D];
        If GB=1 then GB:=Col;
        If GB<>0 then
          Mem[Seg(BT^):Ofs(BT^)+C*17+D]:=GB;
      End;
    ShowImage(BT,X-1,Y,17,16);
  End else
  If YD=-1 then
  Begin
    Move(B1^,BT^,256);
    Os:=(15-(Y and 15)) shl 4;
    For C:=0 to 15 do
    Begin
      D:=Spr[11]^[Os+C];
      Mem[Seg(BT^):Ofs(BT^)+256+C]:=D;
    End;
    For C:=0 to 15 do
      For D:=0 to 15 do
      Begin
        GB:=Sp^[C shl 4+D];
        If GB=1 then GB:=Col;
        If GB<>0 then
          Mem[Seg(BT^):Ofs(BT^)+C shl 4+D]:=GB;
      End;
    ShowImage(BT,X,Y-1,16,17);
  End else
  If YD=1 then
  Begin
    Move(B1^,Ptr(Seg(BT^),Ofs(BT^)+16)^,256);
    Os:=(Y and 15) shl 4;
    For C:=0 to 15 do
    Begin
      D:=Spr[11]^[Os+C];
      Mem[Seg(BT^):Ofs(BT^)+C]:=D;
    End;
    For C:=0 to 15 do
      For D:=0 to 15 do
      Begin
        GB:=Sp^[C shl 4+D];
        If GB=1 then GB:=Col;
        If GB<>0 then
          Mem[Seg(BT^):Ofs(BT^)+16+C shl 4+D]:=GB;
      End;
    ShowImage(BT,X,Y,16,17);
  End;
End;

Procedure MakeMve;
Var P : Pointer;
Begin
  Move(Spr[Lev[X1M,Y1M].T]^,B1^,256);
  GoMve(B1,Spr[F1+D1*3],X1,Y1+48,X1D,Y1D);
  Inc(X1,X1D);
  Inc(Y1,Y1D);
  If (X1 and 15=0) and (Y1 and 15=0) then
  Begin
    If Lev[X1M+X1D,Y1M+Y1D].T=11 then
    Begin
      A:=Lev[X1M,Y1M].T;
      Lev[X1M,Y1M].T:=11;
      Inc(X1M,X1D);
      Inc(Y1M,Y1D);
      Lev[X1M,Y1M].T:=A;
    End else
    Begin
      Mve:=False;
    End;
  End;
End;

Procedure MoveSpace; forward;

Procedure OneTurn;
Var Xp,Yp : ShortInt;
Sh : Byte;
P : Pointer;
I : Boolean;
Begin
  If Mve then
  Begin
    MakeMve;
    Exit;
  End;
  Yam:=False;
  Inc(Frame);
  If Frame>3 then Frame:=0;
  If Frame=2 then Sh:=0 else If Frame=3 then Sh:=2 else Sh:=Frame;
  If (X1 and 15=0) and (Y1 and 15=0) then
  Begin
    I:=False;
    If ((X1D<>0) or (Y1D<>0)) and (Lev[X1M-X1D,Y1M-Y1D].T=10) then
    Begin
      PlayDigital(8);
      Lev[X1M-X1D,Y1M-Y1D].T:=11;
      Yam:=True;
      X3:=X1M-X1D;
      Y3:=Y1M-Y1D;
    End;
    If Lev[X1M,Y1M].T=14 then
    Begin
      PlayDigital(7);
      ShowImage(B1,X1,Y1+48,16,16);
      A:=Lev[X1M,Y1M].own;
      For B:=1 to 40 do
        For C:=1 to 26 do
          If (Lev[B,C].T=13) and (Lev[B,C].own=A) then
          Begin
            X1M:=B; Y1M:=C; Break;
          End;
      X1:=(X1M-1)*16;
      Y1:=(Y1M-1)*16;
      X1D:=0;
      Y1D:=0;
      GetImage(B1,X1,Y1+48,16,16);
      I:=True;
    End;
    If Lev[X1M,Y1M].T=18 then
    Begin
      EndState:=1;
      Lev[X1M,Y1M].T:=5;
      Move(Spr[5]^,B1^,256);
      I:=True;
    End;
    If Lev[X1M,Y1M].T=17 then
    Begin
      PlayDigital(2);
      HKey[Lev[X1M,Y1M].own]:=True;
      Lev[X1M,Y1M].T:=4;
      Move(Spr[4]^,B1^,256);
      I:=True;
    End;
    If I then
    Begin
      Move(B1^,BT^,256);
      P:=Spr[F1+D1*3+Sh];
      Asm
        mov bl,col
        push ds
        les di,BT
        lds si,P
        mov cx,256
        @1:
        mov al,[si]
        or al,al
        jz @2
        cmp al,1
        jnz @3
        mov al,bl
        @3:
        mov es:[di],al
        @2:
        inc di
        inc si
        loop @1
        pop ds
      end;
      ShowImage(BT,X1,Y1+48,16,16);
    End;
    Xp:=0; Yp:=0;
    If Pressed[scLeft] then Xp:=-1;
    If Pressed[scRight] then Xp:=1;
    If Pressed[scUp] then Yp:=-1;
    If Pressed[scDown] then Yp:=1;
    If Pressed[scSpace] and Not Yam then MoveSpace;
    If (Xp<>0) and (Yp<>0) then Yp:=0;
    X2D:=X1D;Y2D:=Y1D;
    X1D:=0;Y1D:=0;
    If (X1M+xp<=39) and (X1M+xp>=2) and (Y1M+yp<=25) and (Y1M+yp>=2) then
     If (Lev[X1M+xp,Y1M+yp].T in [2..7,10,12..21]) then
     Begin
      If (Lev[X1M+xp,Y1M+yp].T=16) and Not(HKey[Lev[X1M+xp,Y1M+yp].own]) then else
        Begin
          If (Lev[X1M+xp,Y1M+yp].T in [2..7,10,12..21]) then
          Begin
            X1D:=Xp;
            Y1D:=Yp;
            If Xp=1 then D1:=1 else
              If Xp=-1 then D1:=0 else
                If Yp=1 then D1:=3 else
                  If Yp=-1 then D1:=2;
            Inc(X1M,Xp);
            Inc(Y1M,Yp);
            If Lev[X1M,Y1M].T=16 then
            Begin
              PlayDigital(5);
              HKey[Lev[X1M,Y1M].own]:=False;
              Lev[X1M,Y1M].T:=3;
              ShowImage(Spr[3],(X1M-1)*16,Y1M*16+32,16,16);
            End;
          End;
        End;
     End else
     If (Lev[X1M+xp,Y1M+yp].T=11) and (Lev[X1M,Y1M].T in [2,6,7,12,19..21]) then
     Begin
       A:=Lev[X1M,Y1M].T;
       If ((Xp=1) and (A in [19,6])) or ((Xp=-1) and (A in [20,6])) or
          ((Yp=1) and (A in [2,7])) or ((Yp=-1) and (A in [21,7])) or (A=12) then
       Begin
         Mve:=True;
         PlayDigital(6);
         X1D:=Xp;
         Y1D:=Yp;
         If Xp=1 then D1:=1 else
           If Xp=-1 then D1:=0 else
             If Yp=1 then D1:=3 else
               If Yp=-1 then D1:=2;
         A:=Lev[X1M,Y1M].T;
         Lev[X1M,Y1M].T:=11;
         Inc(X1M,Xp);
         Inc(Y1M,Yp);
         Lev[X1M,Y1M].T:=A;
         MakeMve;
         If Yam then
           ShowImage(Spr[11],(X3-1)*16,Y3*16+32,16,16);
         Exit;
       End;
     End;
  End;
  If (X1D<>0) or (Y1D<>0) then
  Begin
    Go(B1,Spr[F1+D1*3+Sh],X1,Y1+48,X1D,Y1D);
    Inc(X1,X1D);
    Inc(Y1,Y1D);
  End;
  If Yam then
  Begin
    ShowImage(Spr[11],(X3-1)*16,Y3*16+32,16,16);
    If Pressed[scSpace] then MoveSpace;
  End;
End;

Procedure ShowInfo;
Var S : String;
Begin
  B:=0;
  For A:=0 to 255 do
    If HKey[A] then
    Begin
      ShowSpr(Spr[17],B,0,16,16,A);
      Inc(B,16);
    End;
  ShowImage(Clean,B,0,16,16);
End;

Function GameOver : Boolean;
Begin
  GameOver:=EndState=1;
End;

Procedure MoveSpace;
Var Xp,Yp,X,Y,Os : LongInt;
OKey : Byte;
Begin
  Repeat Until Not Pressed[scSpace];
  X2:=X1;
  Y2:=Y1;
  Repeat
    GetImage(BT,X2,Y2+48,16,16);
    ShowTrans(Spr[15],X2,Y2+48,16,16);
    OKey:=0;
    Repeat
      Xp:=0;Yp:=0;
      Repeat Until Pressed[scLeft] or Pressed[scRight] or Pressed[scDown]
             or Pressed[scUp] or Pressed[scSpace] or Pressed[scEsc];
      If Pressed[scLeft] then Xp:=-1;
      If Pressed[scRight] then Xp:=1;
      If Pressed[scUp] then Yp:=-1;
      If Pressed[scDown] then Yp:=1;
      If (Xp<>0) or (Yp<>0) then
      Begin
        ShowImage(BT,X2,Y2+48,16,16);
        Inc(X2,Xp*16);
        Inc(Y2,Yp*16);
        If X2<16 then X2:=16;
        If X2>38*16 then X2:=38*16;
        If Y2<16 then Y2:=16;
        If Y2>24*16 then Y2:=24*16;
        GetImage(BT,X2,Y2+48,16,16);
        ShowTrans(Spr[15],X2,Y2+48,16,16);
      End;
      If Xp=1 then B:=scRight;
      If Yp=1 then B:=scDown;
      If Xp=-1 then B:=scLeft;
      If Yp=-1 then B:=scUp;
      A:=1;
      If B<>OKey then C:=WaitTick shl 2 else C:=WaitTick;
      Repeat
        Inc(A);
      Until (A>C) or (Not Pressed[B]);
      If Pressed[B] then OKey:=B else OKey:=1;
      CheckMIDI;
    Until Pressed[scEsc] or ((Pressed[scEnter] or Pressed[scSpace]) and
          (Lev[X2 shr 4+1,Y2 shr 4+1].T in [2,6,7,12,19..21]) and
          ((X1<>X2) or (Y1<>Y2)));
    If Pressed[scEsc] then
    Begin
      ShowImage(BT,X2,Y2+48,16,16);
      Repeat Until Not Pressed[scEsc];
      Exit;
    End;
    ShowTrans(Spr[1],X2,Y2+48,16,16);
    Repeat Until Not(Pressed[scEnter]) and Not Pressed[scSpace];
    Xp:=0;
    Yp:=0;
    Repeat
      If Pressed[scLeft] then Xp:=-1;
      If Pressed[scRight] then Xp:=1;
      If Pressed[scUp] then Yp:=-1;
      If Pressed[scDown] then Yp:=1;
      If Pressed[scEsc] or Pressed[scSpace] then Break;
      If (Xp<>0) and (Yp<>0) then Yp:=0;
    Until (Xp<>0) or (Yp<>0);
    ShowImage(BT,X2,Y2+48,16,16);
    If (Xp<>0) or (Yp<>0) then
    Begin
      PlayDigital(6);
      If Xp=1 then Repeat Until Not Pressed[scRight];
      If Yp=1 then Repeat Until Not Pressed[scDown];
      If Xp=-1 then Repeat Until Not Pressed[scLeft];
      If Yp=-1 then Repeat Until Not Pressed[scUp];
      X:=X2 shr 4+1;Y:=Y2 shr 4+1;
      E:=Lev[X,Y].T;
      D:=0;
      If (Lev[X+xp,Y+yp].T=11) and (((Xp=1) and (E in [19,6])) or
         ((Xp=-1) and (E in [20,6])) or ((Yp=1) and (E in [2,7])) or
         ((Yp=-1) and (E in [21,7])) or (E=12)) then
      Repeat
        If (X2 and 15=0) and (Y2 and 15=0) then
        Begin
          If Lev[X+Xp,Y+Yp].T<>11 then
          Begin
            D:=1;
          End else
          Begin
            Lev[X,Y].T:=11;
            Inc(X,Xp);
            Inc(Y,Yp);
            Lev[X,Y].T:=E;
          End;
        End;
        If (D<>1) and ((Xp<>0) or (Yp<>0)) then
        Begin
          ShowImage(BT,X2+Xp,Y2+48+Yp,16,16);
          If Xp=1 then
          Begin
            Os:=X2 and 15;
            For A:=0 to 15 do
              PutPixel(X2,Y2+A+48,Spr[11]^[A shl 4+Os]);
          End else
          If Xp=-1 then
          Begin
            Os:=15-X2 and 15;
            For A:=0 to 15 do
              PutPixel(X2+15,Y2+A+48,Spr[11]^[A shl 4+Os]);
          End else
          If Yp=1 then
          Begin
            Os:=(Y2 and 15) shl 4;
            For A:=0 to 15 do
              PutPixel(X2+A,Y2+48,Spr[11]^[Os+A]);
          End else
          If Yp=-1 then
          Begin
            Os:=(15-(Y2 and 15)) shl 4;
            For A:=0 to 15 do
              PutPixel(X2+A,Y2+48+15,Spr[11]^[Os+A]);
          End;
          Inc(X2,Xp);
          Inc(Y2,Yp);
        End;
        For A:=0 to WaitCycle do ;
      Until (D=1);
      X2:=(X-1)*16;
      Y2:=(Y-1)*16;
    End else
      Repeat Until Not Pressed[scSpace] and Not Pressed[scEsc];
  Until Pressed[scEsc];
End;

Procedure PlayLev;
Begin
  InitGame;
  EscExit:=False;
  Repeat
    If Pressed[scQ] and Pressed[scA] and Pressed[scZ] then EndState:=1;
    OneTurn;
    ShowInfo;
    If (Pressed[scGrayPlus] or Pressed[scEqual]) and (CurSpeed>0) then
    Begin
      Dec(CurSpeed,10);
      ShowSpeed;
      Repeat Until Not Pressed[scGrayPlus] and Not Pressed[scEqual];
    End;
    If (Pressed[scMinus] or Pressed[scGrayMinus]) and (CurSpeed<150) then
    Begin
      Inc(CurSpeed,10);
      ShowSpeed;
      Repeat Until Not Pressed[scMinus] and Not Pressed[scGrayMinus];
    End;
    For A:=0 to WaitCycle do ;
    CheckMIDI;
    If Pressed[scN] then
    Begin
      Inc(MNum);
      If MNum>MMax-1 then MNum:=0;
      PLAYMIDI;
    End;
    If Pressed[scEsc] then
    Begin
      Repeat Until Not Pressed[scEsc];
      Print('  ? (Y/N)',244,18,13);
      Repeat Until Pressed[scY] or Pressed[scN] or Pressed[scEsc];
      If Pressed[scY] then
        EscExit:=True;
      For A:=0 to 10 do
        ShowImage(Clean,244+A*16,18,16,16);
      Repeat Until Not Pressed[scY] and Not Pressed[scN] and Not Pressed[scEsc];
    End;
  Until EscExit or Pressed[scR] or GameOver;
  If Pressed[scEsc] then EndState:=0;
  If Pressed[scR] then Begin PlayDigital(4); EndState:=2; End;
  Repeat Until Not Pressed[scEsc] and not Pressed[scR];
  FreeMem(B1,256);
  FreeMem(BT,17*16);
End;

End.